package ch.psi.daq.queryrest.response;

import java.io.IOException;
import java.util.Map.Entry;
import java.util.stream.Stream;

import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletResponse;

import ch.psi.daq.query.model.impl.DAQQuery;

public interface ResponseStreamWriter {

   /**
    * Responding with the the contents of the stream by writing into the output stream of the
    * {@link ServletResponse}.
    * 
    * @param stream Mapping from channel name to data
    * @param query concrete instance of {@link DAQQuery}
    * @param response {@link ServletResponse} instance given by the current HTTP request
    * @throws IOException thrown if writing to the output stream fails
    */
   public void respond(Stream<Entry<String, ?>> stream, DAQQuery query, HttpServletResponse response) throws Exception;
}
