package ch.psi.daq.queryrest.response.csv;

import java.lang.reflect.Array;

import org.supercsv.cellprocessor.CellProcessorAdaptor;
import org.supercsv.cellprocessor.ift.CellProcessor;
import org.supercsv.util.CsvContext;

public class ArrayProcessor extends CellProcessorAdaptor {
   public static final char DEFAULT_SEPARATOR = ',';
   public static final String OPEN_BRACKET = "[";
   public static final String CLOSE_BRACKET = "]";

   private char separator = DEFAULT_SEPARATOR;

   public ArrayProcessor() {
      super();
   }

   public ArrayProcessor(char separator) {
      super();
      this.separator = separator;
   }

   public ArrayProcessor(CellProcessor next) {
      super(next);
   }

   public ArrayProcessor(CellProcessor next, char separator) {
      super(next);
      this.separator = separator;
   }

   @Override
   public Object execute(Object value, CsvContext context) {
      if (value.getClass().isArray()) {
         StringBuilder buf = new StringBuilder();
         
         int length = Array.getLength(value);
         buf.append(OPEN_BRACKET);
         for (int i = 0; i < length;) {
            Object val = next.execute(Array.get(value, i), context);
            buf.append(val);

            ++i;
            if (i < length) {
               buf.append(separator);
            }
         }
         buf.append(CLOSE_BRACKET);

         return buf.toString();
      } else {
         return next.execute(value, context);
      }
   }
}
